# $Id: jabberd.spec 751 2007-04-11 17:06:05Z rpmbuild $

%define conference_version 0.6.0
%define jud_version 0.5
%define aim_version 20040131
%define msn_version 1.3.0
%define yahoo_version 2.3.2
%define user jabberd

Summary: jabberd14/XMPP instant messaging server
Name: jabberd
Version: 1.4.4
Release: %RErelease 3
Epoch: 0
License: Jabber Open Source License/GPL
Group: System Environment/Daemons
URL: http://jabberd.org/
Source0: http://download.jabberd.org/jabberd14/%{name}-%{version}.tar.gz
Source2: jabberd.init.redhat
Source3: jabberd.sysconfig
Source6: jabberd-aim.xml
Source7: jabberd-aim.init.redhat
Source10: http://jabberstudio.org/projects/mu-conference/releases/mu-conference-%{conference_version}.tar.gz
Source11: http://jud.jabberstudio.org/jud-%{jud_version}.tar.gz
Source12: jabberd-conference.xml
Source13: jabberd-conference.init.redhat
Source14: jabberd-msn.xml
Source15: jabberd-msn.init.redhat
Source16: jabberd-jud.xml
Source17: jabberd-jud.init.redhat
Source18: jabberd-yahoo.xml
Source19: jabberd-yahoo.init.redhat
Source20: http://aim-transport.jabberstudio.org/aim-transport-stable-%{aim_version}b.tar.gz
Source22: http://msn-transport.jabberstudio.org/msn-transport-%{msn_version}.tar.gz
Source23: http://jabberstudio.org/projects/yahoo-transport-2/releases/yahoo-transport-%{yahoo_version}.tar.gz
Patch0: jabber-1.4.4-xmlformat.patch
Patch1: jabber-1.4.4-xmlconfig.patch
Patch2: libjabber-fix-includes.patch
Patch3: jabber-1.4.4-gcc4.patch
Patch4: jabber-1.4.4-fixbuild.patch
Patch5: jabber-1.4.4-sqlbuild.patch
Patch6: jabber-1.4.4-soname.patch
Patch7: jabber-1.4.4-pic.patch
BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-root
Requires: pth, openssl >= 0.9.7, expat, libidn
BuildRequires: pth-devel, curl-devel >= 7.12.0, openssl-devel >= 0.9.7
BuildRequires: libsigc++-devel, glib2-devel, glib-devel, automake14
BuildRequires: automake >= 1.9, gettext-devel, libidn-devel, expat-devel
Provides: jabberd14

%description
Jabberd provides an open-source server implementation of the Jabber/XMPP
protocols for instant messaging and XML routing. The goal of the project
is to provide a scalable, reliable, efficient and extensible server that
provides a complete set of features and is up to date with the latest
protocol revisions.

%package devel
Summary: Include files and libraries used to develop jabberd
Group: System Environment/Daemons
Requires: %{name} = %{version}

%description devel
Include files and libraries used to develop jabberd.

%package jud
Summary: Jabber User Directory service for jabberd server
Group: System Environment/Daemons
Requires: %{name} = %{version}
Provides: jabber-jud

%description jud
This package contains user directory service for jabberd server.

WARNING : to enable support for this transport, you must :
- uncomment jud part in %{_sysconfdir}/%{name}/%{name}.xml 
- edit %{_sysconfdir}/%{name}/%{name}.xml and %{_sysconfdir}/%{name}/%{name}-jud.xml to 
  replace jud.localhost with jud.your_computer_full_domain_name
- configure your DNS server to resolve jud.your_computer_full_domain_name

%package conference
Summary: Conferencing service for jabberd server
Group: System Environment/Daemons
Requires: %{name} = %{version}
Provides: jabber-conference

%description conference
This package contains conference service for jabberd server.

WARNING : to enable support for this transport, you must :
- uncomment conference part in %{_sysconfdir}/%{name}/%{name}.xml 
- edit %{_sysconfdir}/%{name}/%{name}.xml and %{_sysconfdir}/%{name}/%{name}-conference.xml 
  to replace conference.localhost with conference.your_computer_full_domain_name
- configure your DNS server to resolve conference.your_computer_full_domain_name 

%package aim
Summary: AIM transport for jabberd server
Group: System Environment/Daemons
Requires: %{name} = %{version}
Provides: jabber-aim-transport, jabber-icq-transport
Obsoletes: jabber-icq

%description aim
This package contains AIM transport for jabberd server.

WARNING : to enable support for this transport, you must :
- uncomment aim part in %{_sysconfdir}/%{name}/%{name}.xml 
- edit %{_sysconfdir}/%{name}/%{name}.xml and %{_sysconfdir}/%{name}/%{name}-aim.xml to 
  replace aim.localhost with aim.your_computer_full_domain_name
- configure your DNS server to resolve aim.your_computer_full_domain_name

%package msn
Summary: MSN transport for jabberd server
Group: System Environment/Daemons
Requires: %{name} = %{version}
Provides: jabber-msn-transport

%description msn
This package contains MSN transport for jabberd server.

WARNING : to enable support for this transport, you must :
- uncomment msn part in %{_sysconfdir}/%{name}/%{name}.xml 
- edit %{_sysconfdir}/%{name}/%{name}.xml and %{_sysconfdir}/%{name}/%{name}-msn.xml to 
  replace msn.localhost with msn.your_computer_full_domain_name
- configure your DNS server to resolve msn.your_computer_full_domain_name

%package yahoo
Summary: Yahoo transport for jabberd server
Group: System Environment/Daemons
Requires: %{name} = %{version}
Provides: jabber-yahoo-transport

%description yahoo
This package contains Yahoo transport for jabberd server.

WARNING : to enable support for this transport, you must :
- uncomment yahoo part in %{_sysconfdir}/%{name}/%{name}.xml 
- edit %{_sysconfdir}/%{name}/%{name}.xml and %{_sysconfdir}/%{name}/%{name}-yahoo.xml to 
  replace yahoo.localhost with yahoo.your_computer_full_domain_name
- configure your DNS server to resolve yahoo.your_computer_full_domain_name


%prep 
%define certdir /usr/share/ssl/certs
%if "%errata" >= "140"
%define certdir /etc/pki/tls/certs
%endif
%setup -q -a 10 -a 11 -a 20 -a 22 -a 23  -n %{name}-%{version}
%patch0 -p 1 -b .xmlformat
%patch1 -p 1 -b .xmlconfig
%patch2 -p 1 -b .fixinclude
%patch3 -p 1 -b .gcc4
%patch4 -p 1 -b .fixbuild
%patch5 -p 1 -b .sqlbuild
%patch6 -p 1 -b .soname
# needs to be applied last since it patches plugins too
%patch7 -p 1 -b .pic
# needed by patches 9 & 10
%{__aclocal}
%{__automake}
%{__autoconf}
# needed by patch 9
cd aim-transport-stable-%{aim_version}
touch NEWS
automake-1.4 -a
%{__autoconf}
cd ..
cd msn-transport-%{msn_version}
touch NEWS ChangeLog
%{__aclocal}
%{__automake} -a
cd ..

%build
%configure --enable-legacy \
           --enable-ssl \
           --sysconfdir=%{_sysconfdir}/%{name} \
           --localstatedir=%{_var} \
           --libdir=%{_libdir}/%{name} \
           --bindir=%{_sbindir} \
           --without-ipv6 \
           --without-mysql \
           --without-postgresql \

%{__make}

cd jud-ansi-c
%{__make}
cd ..

cd mu-conference-%{conference_version}
%{__make}
cd ..

cd aim-transport-stable-%{aim_version}
%configure
%{__make}
cd ..

cd msn-transport-%{msn_version}
%configure --with-jabberd=${RPM_BUILD_DIR}/%{name}-%{version}/jabberd --with-pth=%{_includedir} --with-curl-libs=%{_libdir}
%{__make}
cd ..

cd yahoo-transport-%{yahoo_version}
%{__make}
cd ..


%install
[ -n "$RPM_BUILD_ROOT" -a "$RPM_BUILD_ROOT" != / ] && %{__rm} -rf $RPM_BUILD_ROOT

%define fixfiles %{__sed} -e 's|@libdir@|%{_libdir}/%{name}|g' -e 's|@spooldir@|%{_localstatedir}/lib/%{name}|g' -e 's|@rundir@|%{_localstatedir}/run/%{name}|g' -e 's|@logdir@|%{_localstatedir}/log/%{name}|g' -e 's|@confdir@|%{_sysconfdir}/%{name}|g' -e 's|@user@|%{user}|g'

%makeinstall spooldir=${RPM_BUILD_ROOT}%{_localstatedir}/lib/%{name} \
             libdir=${RPM_BUILD_ROOT}%{_libdir}/%{name} \
             bindir=${RPM_BUILD_ROOT}%{_sbindir} \
             sysconfdir=${RPM_BUILD_ROOT}%{_sysconfdir}/%{name}
%{__mv} ${RPM_BUILD_ROOT}%{_libdir}/%{name}/libjabberd.* ${RPM_BUILD_ROOT}%{_libdir}/
%{__install} -m0755 -d ${RPM_BUILD_ROOT}%{_sysconfdir}/sysconfig/
%fixfiles %{SOURCE3} > ${RPM_BUILD_ROOT}%{_sysconfdir}/sysconfig/jabberd
%{__install} -m0755 -D %{SOURCE2} ${RPM_BUILD_ROOT}%{_initrddir}/jabberd
#%{__install} -m0700 -d ${RPM_BUILD_ROOT}%{_sysconfdir}/%{name}/certs/
%{__sed} -e 's|jabber.pid|jabberd.pid|' -e 's|%{_sysconfdir}/%{name}/certs|%certdir|' ${RPM_BUILD_ROOT}%{_sysconfdir}/%{name}/jabber.xml > ${RPM_BUILD_ROOT}%{_sysconfdir}/%{name}/jabberd.xml.dist
%{__rm} ${RPM_BUILD_ROOT}%{_sysconfdir}/%{name}/jabber.xml ${RPM_BUILD_ROOT}%{_sysconfdir}/%{name}/jabber.xml.dist

# jud
%{__install} -m0755 -D jud-ansi-c/jud.so ${RPM_BUILD_ROOT}%{_libdir}/%{name}/jud/jud.so
%fixfiles %{SOURCE16} > ${RPM_BUILD_ROOT}%{_sysconfdir}/%{name}/jabberd-jud.xml.dist
%{__install} -m0755 %{SOURCE17} ${RPM_BUILD_ROOT}%{_initrddir}/jabberd-jud

# multi-user conference
%{__install} -m0755 -D mu-conference-%{conference_version}/src/mu-conference.so ${RPM_BUILD_ROOT}%{_libdir}/%{name}/mu-conference/mu-conference.so
%fixfiles %{SOURCE12} > ${RPM_BUILD_ROOT}%{_sysconfdir}/%{name}/jabberd-conference.xml.dist
%{__install} -m0755 %{SOURCE13} ${RPM_BUILD_ROOT}%{_initrddir}/jabberd-conference

# aim-transport 
%{__install} -m0755 -D aim-transport-stable-%{aim_version}/src/aimtrans.so ${RPM_BUILD_ROOT}%{_libdir}/%{name}/aim-transport/aimtrans.so
%fixfiles %{SOURCE6} > ${RPM_BUILD_ROOT}%{_sysconfdir}/%{name}/jabberd-aim.xml.dist
%{__install} -m0755 %{SOURCE7} ${RPM_BUILD_ROOT}%{_initrddir}/jabberd-aim

# msn-transport 
%{__install} -m0755 -D msn-transport-1.*/src/msntrans.so ${RPM_BUILD_ROOT}%{_libdir}/%{name}/msn-transport/msntrans.so
%fixfiles %{SOURCE14} > ${RPM_BUILD_ROOT}%{_sysconfdir}/%{name}/jabberd-msn.xml.dist
%{__install} -m0755 %{SOURCE15} ${RPM_BUILD_ROOT}%{_initrddir}/jabberd-msn

# yahoo-transport 
%{__install} -m0755 -D yahoo-transport-%{yahoo_version}/yahoo-transport.so ${RPM_BUILD_ROOT}%{_libdir}/%{name}/yahoo-transport/yahoo-transport.so
%fixfiles %{SOURCE18} > ${RPM_BUILD_ROOT}%{_sysconfdir}/%{name}/jabberd-yahoo.xml.dist
%{__install} -m0755 %{SOURCE19} ${RPM_BUILD_ROOT}%{_initrddir}/jabberd-yahoo

# remove unpackaged files
%{__rm} -f ${RPM_BUILD_ROOT}%{_libdir}/%{name}/*.la
%{__rm} -f ${RPM_BUILD_ROOT}%{_libdir}/%{name}/libjabberdxdbsql.*

cat << EOF > README.ssl

To enable SSL support in jabberd, you must modify %{_sysconfdir}/%{name}/jabberd.xml :
- Uncomment one of the lines <ssl port='5223'>127.0.0.1</ssl> by adding your 
  server IP address (Be sure to include an IP address otherwise, you will get 
  nothing but a 1GB error logfile.
- Uncomment one of the lines <key id='127.0.0.1'>%{certdir}/%{name}.pem</key>
  and replace 127.0.0.1 with your server IP address.
- Create a SSL test key in %certdir by changing into that directory
  and running "make %{name}.pem && chown %{user}:%{user} %{name}.pem;
  chmod 0600 %{name}.pem".

EOF


%clean
[ -n "$RPM_BUILD_ROOT" -a "$RPM_BUILD_ROOT" != / ] && %{__rm} -rf $RPM_BUILD_ROOT


%pre
# Add the jabberd user if there is not one
getent passwd %{user} >/dev/null 2>&1
if [ $? -ne 0 ]; then
 /usr/sbin/groupadd -g 107 %{user}
 /usr/sbin/useradd -r -u 107 -g %{user} -c "Jabber Daemon" -M -d %{_localstatedir}/lib/%{name} -s /bin/false %{user}
fi

%post 
/sbin/chkconfig --add %{name}

%preun
# Only if we are not upgrading...
if [ "$1" = 0 ]; then
  /sbin/service %{name} stop > /dev/null 2>&1
  /sbin/chkconfig --del %{name}
fi

%postun
# Only if we are upgrading...
if [ "$1" -ge "1" ]; then
  /sbin/service %{name} condrestart > /dev/null 2>&1
else
 /usr/sbin/userdel %{user} 2>/dev/null || :
 /usr/sbin/groupdel %{user} 2>/dev/null || :
fi

%post conference
/sbin/chkconfig --add %{name}-conference

%preun conference
# Only if we are not upgrading...
if [ "$1" = 0 ]; then
  /sbin/service %{name}-conference stop > /dev/null 2>&1
  /sbin/chkconfig --del %{name}-conference
fi

%postun conference
# Only if we are upgrading...
if [ "$1" -ge "1" ]; then
  /sbin/service %{name}-conference condrestart > /dev/null 2>&1
fi

%post jud
/sbin/chkconfig --add %{name}-jud

%preun jud
# Only if we are not upgrading...
if [ "$1" = 0 ]; then
  /sbin/service %{name}-jud stop > /dev/null 2>&1
  /sbin/chkconfig --del %{name}-jud
fi

%postun jud
# Only if we are upgrading...
if [ "$1" -ge "1" ]; then
  /sbin/service %{name}-jud condrestart > /dev/null 2>&1
fi

%post aim
/sbin/chkconfig --add %{name}-aim

%preun aim
# Only if we are not upgrading...
if [ "$1" = 0 ]; then
  /sbin/service %{name}-aim stop > /dev/null 2>&1
  /sbin/chkconfig --del %{name}-aim
fi

%postun aim
# Only if we are upgrading...
if [ "$1" -ge "1" ]; then
  /sbin/service %{name}-aim condrestart > /dev/null 2>&1
fi

%post msn
/sbin/chkconfig --add %{name}-msn

%preun msn
# Only if we are not upgrading...
if [ "$1" = 0 ]; then
  /sbin/service %{name}-msn stop > /dev/null 2>&1
  /sbin/chkconfig --del %{name}-msn
fi

%postun msn
# Only if we are upgrading...
if [ "$1" -ge "1" ]; then
  /sbin/service %{name}-msn condrestart > /dev/null 2>&1
fi

%post yahoo
/sbin/chkconfig --add %{name}-yahoo

%preun yahoo
# Only if we are not upgrading...
if [ "$1" = 0 ]; then
  /sbin/service %{name}-yahoo stop > /dev/null 2>&1
  /sbin/chkconfig --del %{name}-yahoo
fi

%postun yahoo
# Only if we are upgrading...
if [ "$1" -ge "1" ]; then
  /sbin/service %{name}-yahoo condrestart > /dev/null 2>&1
fi


%files
%defattr(-,root,root)
%doc AUTHORS ChangeLog INSTALL NEWS README* TODO UPGRADE
%dir %{_sysconfdir}/%{name}
#%attr(700,%{user},%{user}) %dir %{_sysconfdir}/%{name}/certs
%{_sysconfdir}/%{name}/jabberd.xml.dist
%config(noreplace) %{_sysconfdir}/sysconfig/jabberd
%{_initrddir}/jabberd
%dir %{_libdir}/%{name}
%{_libdir}/%{name}/*.so
%{_sbindir}/*
%doc %{_mandir}/*/*
%attr(700,%{user},%{user}) %dir %{_localstatedir}/lib/%{name}
%attr(750,%{user},%{user}) %dir %{_localstatedir}/log/%{name}
%attr(700,%{user},%{user}) %dir %{_localstatedir}/run/%{name}
%{_libdir}/*.so.*

%files devel
%defattr(-,root,root)
%{_libdir}/*.so
%{_libdir}/*.la
%{_includedir}/*

%files jud
%defattr(-,root,root)
%docdir %{_docdir}/%{name}
%doc jud-ansi-c/README jud-ansi-c/ChangeLog
%{_initrddir}/jabberd-jud
%{_sysconfdir}/%{name}/jabberd-jud.xml.dist
%{_libdir}/%{name}/jud

%files conference
%defattr(-,root,root)
%docdir %{_docdir}/%{name}
%doc mu-conference-%{conference_version}/README mu-conference-%{conference_version}/AUTHORS
%doc mu-conference-%{conference_version}/TODO mu-conference-%{conference_version}/COPYING
%doc mu-conference-%{conference_version}/ChangeLog mu-conference-%{conference_version}/FAQ
%{_initrddir}/jabberd-conference
%{_sysconfdir}/%{name}/jabberd-conference.xml.dist
%{_libdir}/%{name}/mu-conference

%files aim
%defattr(-,root,root)
%docdir %{_docdir}/%{name}
%doc aim-transport-stable-%{aim_version}/README aim-transport-stable-%{aim_version}/AUTHORS
%doc aim-transport-stable-%{aim_version}/ChangeLog aim-transport-stable-%{aim_version}/NEWS
%doc aim-transport-stable-%{aim_version}/COPYING aim-transport-stable-%{aim_version}/INSTALL
%doc aim-transport-stable-%{aim_version}/TODO
%{_initrddir}/jabberd-aim
%{_sysconfdir}/%{name}/jabberd-aim.xml.dist
%{_libdir}/%{name}/aim-transport

%files msn
%defattr(-,root,root)
%docdir %{_docdir}/%{name}
%doc msn-transport-%{msn_version}/AUTHORS msn-transport-%{msn_version}/ChangeLog
%doc msn-transport-%{msn_version}/NEWS msn-transport-%{msn_version}/README
%{_initrddir}/jabberd-msn
%{_sysconfdir}/%{name}/jabberd-msn.xml.dist
%{_libdir}/%{name}/msn-transport

%files yahoo
%defattr(-,root,root)
%docdir %{_docdir}/%{name}
%doc yahoo-transport-%{yahoo_version}/CHANGES yahoo-transport-%{yahoo_version}/INSTALL
%doc yahoo-transport-%{yahoo_version}/LICENSE yahoo-transport-%{yahoo_version}/README
%{_initrddir}/jabberd-yahoo
%{_sysconfdir}/%{name}/jabberd-yahoo.xml.dist
%{_libdir}/%{name}/yahoo-transport


%changelog
* Tue Apr 10 2007 RazorsEdge Packaging <rpmpackaging@razorsedge.org> 1.4.4-3
- Fixed init script error codes to be LSB compliant.

* Mon Jan 08 2007 RazorsEdge Packaging <rpmpackaging@razorsedge.org> 1.4.4-2
- Added '--check $prog ' to daemon line in transport init scripts.
- Fixed Yahoo transport config error.

* Sat Mar 04 2006 RazorsEdge Packaging <rpmpackaging@razorsedge.org> 1.4.4-1
- First release.

